/****************************************************************************


Dieses Programm steuert den kleinen Roboter Hans.
Hans ist ein Linienfinder (Linefinder). Das heit, er folgt einer schwarzen Linie, 
die irgendwo auf dem Fuboden o.. aufgemalt ist.

Die Pins sind folgendermaen belegt:
PC4		Eingang fr das analoge Signal des rechten Fototransistors
PC5	Eingang fr das analoge Signal des rechten Fototransistors

PB1		PWM(OCRA)-Ausgang fr Servo1 -> 1-2EN (L293D)
PB2		PWM(OCRB)-Ausgang fr Servo2 -> 3-4EN (L293D)

PD0		Ausgang fr LED

PD1		1A (L293D)
PD2		2A (L293D)
PD3		4A (L293D)
PD4		3A (L293D)


****************************************************************************/
//Inkludierungen
#include <avr/io.h>    
#include <inttypes.h>
#define F_CPU 1000000UL  // 1 MHz
#include <util/delay.h>
#include <stdint.h>
#include "messen.h"

/****************************************************************************/
//Macros 
#define ledon PORTD &=~_BV(PD0); 
#define ledoff PORTD |= _BV(PD0); 

/****************************************************************************/
//globale Variablen
int sample, i,r,l ;

/****************************************************************************/
//Zeitschschleife
void warte(unsigned int ms)
{
	while(ms>0)
	{
		ms--;
		_delay_ms(0.96);
	}
}


void MESSEN (void){

	l=MESSWERT(5) ; r=MESSWERT(4);
}




//Fahrfunktionen mit PWM
void vorwaerts(void){
	
	OCR1A=l/1.25;// PWM
	PORTD &=~_BV(PD1); PORTD |=_BV(PD2);// rotate forward left
	
	OCR1B=r/1.25;// PWM
	PORTD |=_BV(PD3);PORTD &=~_BV(PD4);// rotate forward right

}
	
void stop(void){
	PORTB &=~_BV(PB1); PORTB &=~_BV(PB2);	
	OCR1A=0;OCR1B=0;
	
}

	
void rueckwaerts(void){
	
	OCR1A=l;// PWM
	PORTD &=~_BV(PD2); PORTD |=_BV(PD1);// rotate backward left
	
	OCR1B=r;// PWM
	PORTD |=_BV(PD4);PORTD &=~_BV(PD3);// rotate backward right

}

/****************************************************************************/
int main(void){ 

	
//Initialisierung der Datenrichtungsregister
  	DDRC=0; //Eingaenge
  	//PORTC=0;
  	DDRB=255; DDRD=255;    // PORTB & PORTD als Ausgabe
	


// Timer 1 fr PWM-Nutzung initialisieren 
    TCCR1A = (1 << WGM11); // mode 14, fast pwm, update at top
    TCCR1B = (1 << WGM13)  // tov1 flag set on top
           | (1 << WGM12)  // top = ICR1
           | (1 << CS11)   // clock select clk/64
           | (1 << CS10);
    ICR1 = 255;

// OC1A als PWM-Port setzen
    DDRB |= (1 << PB1);
    TCCR1A |= (1 << COM1A1);
    

// OC1B als PWM-Port setzen 
    DDRB |= (1 << PB2);
    TCCR1A |= (1 << COM1B1);
    
	ledon;

	while(1){
		
		
		MESSEN(); 
		
		while ( (l>65) && (r>65)) {
			stop(); l=25; r=25;rueckwaerts();warte(500);
		}
		
		vorwaerts();warte(50);

	}

	return 0;
  
}

